chrome.runtime.onMessage.addListener((request, sender, callback) => {
    if (typeof (request['_jsObject']) !== "undefined") {
        request = request['_jsObject'];
    }
    if (typeof (request.action) !== "undefined") {
        switch (request.action) {
            case 'http_request':
                let xmlHttpRequest = new XMLHttpRequest();

                let method = request.method ? request.method.toUpperCase() : 'GET';

                xmlHttpRequest.onload = () => {
                    callback({
                        error: false,
                        result: xmlHttpRequest.responseText,
                        status: xmlHttpRequest.status
                    });
                };

                xmlHttpRequest.onerror = () => {
                    callback({
                        error: true,
                        result: '',
                        status: xmlHttpRequest.status
                    });
                };

                xmlHttpRequest.open(method, request.url, true);

                if (typeof (request.headers) !== "undefined") {
                    for (let key in request.headers) {
                        xmlHttpRequest.setRequestHeader(key, request.headers[key]);
                    }
                }

                xmlHttpRequest.withCredentials = request.withCredentials;

                xmlHttpRequest.send(request.body);

                return true;
        }
    }

    // Unknown message, so we just forward the callback to close the message port
    if (callback) callback();
});
